/*
 * test.java
 *
 * Created on 31  2003 ., 15:04
 */

package ntest;

import javax.microedition.lcdui.*;

/**
 *
 * @author  Pavlenko
 */ 

public class Test extends Canvas implements Runnable{
  Thread thread=null;
  ntestMIDlet mid=null;

  long nextTime=0;
  long curTime=0;

  int nFPS=0;

  int w;int h;

  Image iFPS=null;
  Graphics gFPS=null;

  /** Creates a new instance of test */
  public Test(ntestMIDlet n) {
    mid=n;
    iFPS=Image.createImage(35,15);
    gFPS=iFPS.getGraphics();
    thread=new Thread(this);
    thread.start();
    w=getWidth();
    h=getHeight();
  }

  public void keyPressed(int keyCode){
      thread=null;
      mid.exit();
  }

  void fixFPS(){
    gFPS.setColor(200,200,200);
    gFPS.fillRect(0,0,35,15);
    gFPS.setColor(0,0,0);
    gFPS.drawString("FPS: "+nFPS,0,0,gFPS.LEFT|gFPS.TOP);
    nFPS=0;
    nextTime=curTime+1000;
  }

  public void paint(Graphics g){
    g.setColor(200,200,200);
    g.fillRect(0,0,w,h);
    g.setColor(0,0,0);
    g.drawRect(0,0,w-1,h-1);
    if (iFPS!=null)g.drawImage(iFPS,3,1,g.LEFT|g.TOP);
    g.drawString(""+w+"x"+h,3,14,g.LEFT|g.TOP);
  }

  public void run() {
    Thread current=Thread.currentThread();
    while (current==thread){
      nFPS++;
      if (curTime>=nextTime)fixFPS();
      curTime=System.currentTimeMillis();
      repaint();
      try{
        Thread.sleep(10);
      }
      catch (Exception e){};
      serviceRepaints();
    }
  }

}

